//
// merges many files into one file
//
// Written by Maxwell Sayles.  Copyright (C) 2000.
//

#ifndef FILE_MERGER__INCLUDED
#define FILE_MERGER__INCLUDED

#include <windows.h>

class FileMerger
{

// creation/destruction
public:
	FileMerger (char* outFileName, char** list_inFileNames, int number_inFiles, int bufferSizeInKB, bool deleteFiles);
	virtual ~FileMerger ();

// interface
public:
	
	// is finished?
	bool isFinished ();

	// copy one buffer worth of data
	void copyOneBuffer ();

	// return the name of the current input file
	char* currentInputFile () { return this->list_inFileNames [this->index_fileList]; }

	// return the name of the current output file
	char* currentOutputFile () { return this->outFileName; }

	// return the name of the current output file title (without path)
	char* currentOutputFileTitle () { return this->outFileTitle; }
	
	// return percentage of current input file read
	float inputPercentComplete () { return ((float)(this->bytesReadOfInput) * 100.f / (float)(this->bytesToReadOfInput)); }
	
	// return percentage of output file
	float ouputPercentComplete () { return ((float)(this->bytesWrittenOfOutput) * 100.f / (float)(this->totalSize)); }

	// return the number of input files
	int numberOfInputFiles () { return this->number_inFiles; }

	// return the index of the current input file
	int inputIndexInFileList () { return this->index_fileList; }


	bool									error;
	DWORD									errorCode;
	bool									completed;



// secret
private:

	bool									deleteFiles;

	char*									outFileName;
	char*									outFileTitle;
	INT64									totalSize;

	char**								list_inFileNames;
	INT64*								list_inFileSizes;
	int										number_inFiles;

	int										index_fileList;

	int										bufferSize;  // in bytes
	BYTE*									buffer;
	
	INT64									bytesReadOfInput;
	INT64									bytesToReadOfInput;
	INT64									bytesWrittenOfOutput;
	
	HANDLE								outFile;
	HANDLE								inFile;
};


#endif // FILE_MERGER__INCLUDED
