//
// merge dialog
//
// Written by Maxwell Sayles.  Copyright (C) 2000.
//

#ifndef MERGE__DIALOG__INCLUDED
#define MERGE__DIALOG__INCLUDED

#include <windows.h>

//
// merge class
//
class Merge_Dialog
{
// public interface
public:

// static dispatching routine
  static BOOL CALLBACK DialogProc (HWND hWndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

// creation/destruction
	Merge_Dialog () : hWnd (0), isPaused (false) {}

// user interface
public:
	void setUI_inputFileName (const char* inFileName);
	void setUI_outputFileName (const char* outFileName);
	void setUI_inputPercentage (float percentage);
	void setUI_outputPercentage (float percentage);

	void pause ();

	void close () { PostMessage (this->hWnd, WM_CLOSE, 0, 0); }

	bool isPaused;

// protected
protected:
	void initDialog ();

// secret
private:
	HWND hWnd;

}; // class Merger_Dialog

#endif // MERGE__DIALOG__INCLUDED